]> jfr.im git - yt-dlp.git/blame - devscripts/release.sh
release 2015.02.02.5
[yt-dlp.git] / devscripts / release.sh
CommitLineData
55e286ba 1#!/bin/bash
225dceb0 2
b962b76f 3# IMPORTANT: the following assumptions are made
6e3dba16 4# * the GH repo is on the origin remote
b962b76f
FV
5# * the gh-pages branch is named so locally
6# * the git config user.signingkey is properly set
7
8# You will need
9# pip install coverage nose rsa
10
6e3dba16
FV
11# TODO
12# release notes
13# make hash on local files
14
b962b76f
FV
15set -e
16
0f8f0971
PH
17skip_tests=true
18if [ "$1" = '--run-tests' ]; then
19 skip_tests=false
d3a8613b 20 shift
d71cae62 21fi
964ac8b5 22
225dceb0
FV
23if [ -z "$1" ]; then echo "ERROR: specify version number like this: $0 1994.09.06"; exit 1; fi
24version="$1"
4c094185
PH
25major_version=$(echo "$version" | sed -n 's#^\([0-9]*\.[0-9]*\.[0-9]*\).*#\1#p')
26if test "$major_version" '!=' "$(date '+%Y.%m.%d')"; then
27 echo "$version does not start with today's date!"
28 exit 1
29fi
30
225dceb0 31if [ ! -z "`git tag | grep "$version"`" ]; then echo 'ERROR: version already present'; exit 1; fi
b962b76f 32if [ ! -z "`git status --porcelain | grep -v CHANGELOG`" ]; then echo 'ERROR: the working directory is not clean; commit or stash changes'; exit 1; fi
50144133
PH
33useless_files=$(find youtube_dl -type f -not -name '*.py')
34if [ ! -z "$useless_files" ]; then echo "ERROR: Non-.py files in youtube_dl: $useless_files"; exit 1; fi
b962b76f
FV
35if [ ! -f "updates_key.pem" ]; then echo 'ERROR: updates_key.pem missing'; exit 1; fi
36
a72b0f2b 37/bin/echo -e "\n### First of all, testing..."
434eb6f2 38make cleanall
964ac8b5 39if $skip_tests ; then
d71cae62
PH
40 echo 'SKIPPING TESTS'
41else
42 nosetests --verbose --with-coverage --cover-package=youtube_dl --cover-html test --stop || exit 1
43fi
b962b76f 44
a72b0f2b 45/bin/echo -e "\n### Changing version in version.py..."
4da769cc 46sed -i "s/__version__ = '.*'/__version__ = '$version'/" youtube_dl/version.py
b962b76f 47
63961d87 48/bin/echo -e "\n### Committing README.md and youtube_dl/version.py..."
b962b76f 49make README.md
63961d87 50git add README.md youtube_dl/version.py
225dceb0 51git commit -m "release $version"
b962b76f 52
a72b0f2b 53/bin/echo -e "\n### Now tagging, signing and pushing..."
b962b76f
FV
54git tag -s -m "Release $version" "$version"
55git show "$version"
56read -p "Is it good, can I push? (y/n) " -n 1
57if [[ ! $REPLY =~ ^[Yy]$ ]]; then exit 1; fi
58echo
6e3dba16
FV
59MASTER=$(git rev-parse --abbrev-ref HEAD)
60git push origin $MASTER:master
61git push origin "$version"
b962b76f 62
a72b0f2b 63/bin/echo -e "\n### OK, now it is time to build the binaries..."
b962b76f
FV
64REV=$(git rev-parse HEAD)
65make youtube-dl youtube-dl.tar.gz
6c603ccc
PH
66read -p "VM running? (y/n) " -n 1
67wget "http://localhost:8142/build/rg3/youtube-dl/youtube-dl.exe?rev=$REV" -O youtube-dl.exe
09f9552b
PH
68mkdir -p "build/$version"
69mv youtube-dl youtube-dl.exe "build/$version"
70mv youtube-dl.tar.gz "build/$version/youtube-dl-$version.tar.gz"
db2d6124 71RELEASE_FILES="youtube-dl youtube-dl.exe youtube-dl-$version.tar.gz"
09f9552b
PH
72(cd build/$version/ && md5sum $RELEASE_FILES > MD5SUMS)
73(cd build/$version/ && sha1sum $RELEASE_FILES > SHA1SUMS)
74(cd build/$version/ && sha256sum $RELEASE_FILES > SHA2-256SUMS)
75(cd build/$version/ && sha512sum $RELEASE_FILES > SHA2-512SUMS)
b962b76f 76
d2d1eb5b 77/bin/echo -e "\n### Signing and uploading the new binaries to yt-dl.org ..."
cc88b90e 78for f in $RELEASE_FILES; do gpg --passphrase-repeat 5 --detach-sig "build/$version/$f"; done
ead28ff3
PH
79scp -r "build/$version" ytdl@yt-dl.org:html/tmp/
80ssh ytdl@yt-dl.org "mv html/tmp/$version html/downloads/"
ea93cce4 81ssh ytdl@yt-dl.org "sh html/update_latest.sh $version"
b962b76f 82
a72b0f2b 83/bin/echo -e "\n### Now switching to gh-pages..."
09f9552b
PH
84git clone --branch gh-pages --single-branch . build/gh-pages
85ROOT=$(pwd)
86(
87 set -e
09f9552b 88 ORIGIN_URL=$(git config --get remote.origin.url)
3b83bf8f 89 cd build/gh-pages
09f9552b 90 "$ROOT/devscripts/gh-pages/add-version.py" $version
60607880 91 "$ROOT/devscripts/gh-pages/update-feed.py"
bb289989 92 "$ROOT/devscripts/gh-pages/sign-versions.py" < "$ROOT/updates_key.pem"
09f9552b
PH
93 "$ROOT/devscripts/gh-pages/generate-download.py"
94 "$ROOT/devscripts/gh-pages/update-copyright.py"
69100808 95 "$ROOT/devscripts/gh-pages/update-sites.py"
09f9552b
PH
96 git add *.html *.html.in update
97 git commit -m "release $version"
3b83bf8f 98 git push "$ROOT" gh-pages
bb289989 99 git push "$ORIGIN_URL" gh-pages
09f9552b 100)
253d96f2 101rm -rf build
b962b76f 102
434eb6f2 103make pypi-files
450a30ca 104echo "Uploading to PyPi ..."
4056ad8f 105python setup.py sdist bdist_wheel upload
434eb6f2 106make clean
450a30ca 107
a72b0f2b 108/bin/echo -e "\n### DONE!"